<?php
require('./global.php');
$lang->load('ACP_DATABASE');
@set_time_limit(0);

/**
* format field
* 
* @param string field
* @param string type
*
* @return string field
*/
function formatfield($field, $type) {
	if ($type == 'integer') return $field;
	else {
		$field = addslashes($field);
		$field = str_replace("\t", "\\t", $field);
		$field = str_replace("\r", "\\r", $field);
		$field = str_replace("\n", "\\n", $field);
		//$field = str_replace("'", "\'", $field);
		
		return "'$field'";
	}
}

/**
* close file
*
* @param resource filepointer
*
* @return void
*/
function wbbfclose(&$fp) {
	global $use_gz;
	if ($use_gz) @gzclose($fp);
	else @fclose($fp);	
}

/**
* writes to file
*
* @param resource filepointer
* @param string data
*
* @return void
*/
function wbbfwrite(&$fp, $data) {
	global $use_gz;
	if ($use_gz) @gzwrite($fp, $data);
	else @fwrite($fp, $data);	
}


if (isset($_REQUEST['action'])) $action = $_REQUEST['action'];
else $action = '';







/** create a database backup **/
if ($action == 'backup') {
	checkAdminPermissions('a_can_database_backup', 1);
	
	if (isset($_POST['send'])) {
		// shell backup  	
		if ($_POST['download'] == 2) {
			if (count($_POST['tables'])) {
				require("./lib/config.inc.php");
				
				$shellstring = "mysqldump --add-locks -qela";
				if ($_POST['structure'] == 0) $shellstring .= "t";
				if ($_POST['drop_table'] == 1) $shellstring .= " --add-drop-table"; 
				$shellstring .= " -h{$sqlhost} -u{$sqluser} -p{$sqlpassword} {$sqldb} ";
				$shellstring .= implode(" ", $_POST['tables']);
				if ($_POST['use_gz'] == 1) $shellstring .= " | gzip > ./backup_wBB2_".formatdate("YmdHi", time()).".sql.gz"; 
				else $shellstring .= " > ./backup_wBB2_".formatdate("YmdHi", time()).".sql";
				@system($shellstring);
				
				acp_message($lang->get("LANG_ACP_DATABASE_BACKUP_DONE"));
			}
			else acp_error($lang->get("LANG_ACP_DATABASE_ERROR_1"));	
			
			exit;	
		}
		
		// no tables selected
		if (!$_POST['tables'] || !count($_POST['tables'])) acp_error($lang->get("LANG_ACP_DATABASE_ERROR_1"));
		
		// create backup file
		if (isset($_POST['use_gz']) && $_POST['use_gz'] && function_exists("gzopen")) $use_gz = 1;
		else $use_gz = 0;
		
		if (isset($_POST['download']) && $_POST['download'] == 1) $tmpfilename = "./temp/backup_".md5(uniqid(rand())).($use_gz ? (".gz") : (""));
		else $tmpfilename = "./backup_wBB2_".formatdate("YmdHi", time()).".sql".(($use_gz) ? (".gz") : (""));
		if ($use_gz) $fp = @gzopen($tmpfilename, "w1b");
		else $fp = @fopen($tmpfilename, "w+b");
		
		
		
		// file header 
		@wbbfwrite($fp, "# WoltLab Burning Board $boardversion Database Backup\n# generated: ".formatdate($wbbuserdata['dateformat']." ".$wbbuserdata['timeformat'], time())."\n\n");
		while (list($key, $val) = each($_POST['tables'])) {
			// export structure
			if ($_POST['structure'] == 1) {
				// drop table
				if ($_POST['drop_table'] == 1) @wbbfwrite($fp, "DROP TABLE IF EXISTS $val;\n");
				
				// create table
				@wbbfwrite($fp, "CREATE TABLE $val (\n");
				
				// get fields
				$fieldtypes = array();
				$result = $db->query("DESCRIBE $val");
				$fieldcount = $db->num_rows($result);
				$i = 0;
				while ($row = $db->fetch_array($result)) {
					$name = $row['Field'];
					$type = " ".$row['Type'];
					$fieldtypes[$name] = (!stristr($row['Type'], "ENUM") && ((stristr($row['Type'], "INT") || stristr($row['Type'], "FLOAT") || stristr($row['Type'], "DOUBLE") || stristr($row['Type'], "REAL") || stristr($row['Type'], "DECIMAL") || stristr($row['Type'], "NUMERIC") || stristr($row['Type'], "TIMESTAMP") || stristr($row['Type'], "YEAR"))) ? ("integer") : ("string"));
					
					if ($row['Null'] == "") $null = " NOT NULL";
					else $null = " NULL";
					
					if ($row['Default'] == "") $default = "";
					else $default = " DEFAULT '".$row['Default']."'";
					
					if ($row['Extra'] == "") $extra = "";
					else $extra = " ".$row['Extra'];
					
					// write field data
					@wbbfwrite($fp, "\t".$name.$type.$null.$default.$extra);
					$i++;
					if ($i < $fieldcount) @wbbfwrite($fp, ", \n");
				}
				
				// get keys
				unset($index);
				$result = $db->query("SHOW KEYS FROM $val");
				while ($row = $db->fetch_array($result)) {
					$keyname = $row['Key_name'];
					$comment = (isset($row['Comment'])) ? $row['Comment'] : "";
					$sub_part = (isset($row['Sub_part'])) ? $row['Sub_part'] : "";
					
					if ($keyname != "PRIMARY" && $row['Non_unique'] == 0) $keyname = "UNIQUE|$keyname";
					if ($comment == "FULLTEXT") $keyname = "FULLTEXT|$keyname";
					if (!isset($index[$keyname])) $index[$keyname] = array();
					if ($sub_part > 1) $index[$keyname][] = $row['Column_name']."(".$sub_part.")";
					else $index[$keyname][] = $row['Column_name'];
				} 
				
				// write key data   
				while (list($keyname, $columns) = @each($index)) {
					@wbbfwrite($fp, ", \n");
					if ($keyname == "PRIMARY") @wbbfwrite($fp, "\tPRIMARY KEY (");
					elseif (wbb_substr($keyname, 0, 6) == "UNIQUE") @wbbfwrite($fp, "\tUNIQUE ".wbb_substr($keyname, 7)." (");
					elseif (wbb_substr($keyname, 0, 8) == "FULLTEXT") @wbbfwrite($fp, "\tFULLTEXT ".wbb_substr($keyname, 9)." (");
					else @wbbfwrite($fp, "\tKEY ".$keyname." (");
					@wbbfwrite($fp, implode($columns, ", ").")");
				}
				
				// write table end
				@wbbfwrite($fp, "\n);\n\n");
			}
			// delete all
			elseif ($_POST['delete_all'] == 1) @wbbfwrite($fp, "DELETE FROM $val;\n\n");
			
			// get table data
			$insert_tag = 0;
			$rowcount = 0;
			$result = $db->unbuffered_query("SELECT * FROM $val");
			while ($row = $db->fetch_array($result, MYSQL_ASSOC)) {
				
				$values = '';
				while (list($key2, $field) = each($row)) {
					if ($values != '') $values .= ",".formatfield($field, $fieldtypes[$key2]); 
					else $values = formatfield($field, $fieldtypes[$key2]);
				}
				
				if ($insert_tag == 0) {
					@wbbfwrite($fp, "INSERT INTO $val VALUES ($values)");
					$insert_tag = 1;	
				}
				else @wbbfwrite($fp, ",($values)");
				if ($insert_tag == 1 && $rowcount == 500) {
					@wbbfwrite($fp, ";\n");
					$insert_tag = 0;
					$rowcount = 0;
				}
				$rowcount++;
			}
			
			if ($insert_tag == 1) @wbbfwrite($fp, ";\n");
			@wbbfwrite($fp, "\n\n");
		}
		
		// close backup file
		@wbbfclose($fp);
		
		
		// download file
		if ($_POST['download'] == 1) {
			$filename = "backup_wBB2_" . formatdate("YmdHi", time()) . ".sql" . (($_POST['use_gz'] && function_exists("gzopen")) ? (".gz") : (""));  
			
			// get mime type
			if (preg_match("/Opera\/[0-9]\.[0-9]{1,2}/", $_SERVER['HTTP_USER_AGENT']) || preg_match("/MSIE [0-9]\.[0-9]{1,2}/", $_SERVER['HTTP_USER_AGENT'])) $mime_type = "application/octetstream";
			else $mime_type = "application/octet-stream";
			
			// send file to browser
			header("Content-Type: ".$mime_type);
			header("Expires: ".date("D, d M Y H:i:s"));
			if (preg_match("/MSIE [0-9]\.[0-9]{1,2}/", $_SERVER['HTTP_USER_AGENT'])) {
				header("Content-Disposition: inline; filename=\"".$filename."\"");
				header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
				header("Pragma: public");
			}
			else {
				header("Content-Disposition: attachment; filename=\"".$filename."\"");
				header("Pragma: no-cache");
			}
			
			// output gzip file
			readfile($tmpfilename);
			@unlink($tmpfilename);
		}
		else {
			acp_message($lang->get("LANG_ACP_DATABASE_BACKUP_DONE"));
		}
		exit;	
	}
	
	$result = mysql_list_tables($sqldb);
	$table_options = '';
	while ($row = $db->fetch_array($result)) $table_options .= makeoption($row[0], $row[0], $row[0], 1);
	
	eval("\$tpl->output(\"".$tpl->get("database_backup", 1)."\",1);");
}









/** execute sql query **/
if ($action == 'query') {
	if (!checkAdminPermissions("a_can_database_query") && !checkAdminPermissions("a_can_database_extra")) access_error(1);
	if (isset($_POST['send'])) {
		checkAdminPermissions("a_can_database_query", 1);
		$query = '';
		if (isset($_FILES['uploadfile']['tmp_name']) && $_FILES['uploadfile']['tmp_name'] && is_uploaded_file($_FILES['uploadfile']['tmp_name'])) {
			do {
   				$tempfile = "./temp/sqlimport_".md5(uniqid(rand()));
   			}
			while (file_exists($tempfile));
	
			if (move_uploaded_file($_FILES['uploadfile']['tmp_name'], $tempfile)) {
				@chmod($tempfile, 0777);
			}
			
			if (wbb_strtolower(wbb_substr($_FILES['uploadfile']['name'], - 3)) == ".gz") $query = implode("", gzfile($tempfile));
			else $query = implode("", file($tempfile)); 	
		}
		elseif ($_POST['query']) $query = $_POST['query'];
		elseif ($_POST['filename'] && file_exists($_POST['filename'])) {
			if (wbb_strtolower(wbb_substr($_POST['filename'], - 3)) == ".gz") $query = implode("", gzfile($_POST['filename']));
			else $query = implode("", file($_POST['filename']));
		}
		if ($query != '') {
			include('./lib/class_query.php');
			$sql_query = new query($query);
			$sql_query->doquery();
			
			$lang->items['LANG_ACP_DATABASE_QUERY_DONE'] = $lang->get("LANG_ACP_DATABASE_QUERY_DONE", array('$sqldb' => $sqldb));
			acp_message($lang->get("LANG_ACP_DATABASE_QUERY_DONE"));
		}	
	}
	
	$table_options = '';
	if (checkAdminPermissions("a_can_database_extra")) {
		$result = mysql_list_tables($sqldb);
		while ($row = $db->fetch_array($result)) $table_options .= makeoption($row[0], $row[0], "", 0);
	}
	
	$lang->items['LANG_ACP_DATABASE_QUERY'] = $lang->get("LANG_ACP_DATABASE_QUERY", array('$sqldb' => $sqldb));
	eval("\$tpl->output(\"".$tpl->get("database_query", 1)."\",1);");
}



// OPTIMIZE|REPAIR TABLE
if ($action == 'extra') {
	checkAdminPermissions("a_can_database_extra", 1);
	if (!$_POST['tables'] || !count($_POST['tables'])) acp_error($lang->get("LANG_ACP_DATABASE_ERROR_1"));
	reset($_POST['tables']);
	
	if ($_POST['what'] == 1) while (list($key, $val) = each($_POST['tables'])) $db->unbuffered_query("OPTIMIZE TABLE $val");	
	elseif ($_POST['what'] == 2) while (list($key, $val) = each($_POST['tables'])) $db->unbuffered_query("REPAIR TABLE $val");	
	
	@header("Location: database.php?action=query&sid=$session[hash]");
	exit();
}
?>
